//+------------------------------------------------------------------+
//|                                       Custom Stochastic-X8.4.mq4 |
//|     Make in Russia by lukas1 aka Victor Lukashuk / lukas1@ngs.ru |
//+------------------------------------------------------------------+
//+++======================================================================+++
//+++                      Stochastic-X8.4 vs CCI TT                       +++
//+++======================================================================+++
#property copyright "  Tankk,  1  july  2016,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks-f41/" 

#property description "Make in Russia by lukas1 aka Victor Lukashuk / lukas1@ngs.ru" 
#property description "   "
#property description "Stochastic Oscillator           .    .    %K.   %D -     %K."
#property description "  , ,      ,  Stochastic        ."
//#property version   "3.00"
#property indicator_separate_window
#property indicator_buffers 8

#property indicator_color1  DarkOrchid   //Violet
#property indicator_color2  RoyalBlue    //Blue
#property indicator_color3  OrangeRed    //Red
#property indicator_color4  SeaGreen
#property indicator_color5  Gold
#property indicator_color6  Magenta   //White
#property indicator_color7  White
#property indicator_color8  LimeGreen

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 1
#property indicator_width7 2
#property indicator_width8 1

#property indicator_level1  100
#property indicator_level2  35
#property indicator_level3  15
#property indicator_level4  -15
#property indicator_level5  -35
#property indicator_level6  -100

#property indicator_levelcolor DarkSlateGray // SteelBlue //C'60,61,62' // 
#property indicator_levelstyle STYLE_DOT

//#property indicator_maximum  50
//#property indicator_minimum -50

//+++======================================================================+++
//+++                 Custom indicator input parameters                    +++
//+++======================================================================+++

extern int                 History  =  0;   //   
extern bool              ShowHisto  =  true,
                       ShowStochX8  =  true;
extern int                 Stoch_K  =  13,   //5,    //parameter of D stoch.
                           Stoch_D  =  1,    //parameter of signal line.
                           Stoch_S  =  5;    //parameter of S stoch.
extern ENUM_MA_METHOD    StochMode  =  MODE_LWMA;
extern ENUM_STO_PRICE   StochPrice  =  STO_LOWHIGH;    
extern int              StochShift  =  0;
extern double                 Koef  =  1.2;

extern bool             ShowSignal  =  true;
extern int                SignalMA  =  13;   //5;
extern ENUM_MA_METHOD   SignalMode  =  MODE_LWMA;
extern int             SignalShift  =  0;

extern bool                ShowCCI  =  true;
extern int               CCIPeriod  =  13;           
extern ENUM_APPLIED_PRICE CCIPrice  =  PRICE_TYPICAL;
extern int                CCIShift  =  0;

extern bool            alertsOn        = true;           // alerts on?
extern bool            alertsOnCurrent = false;          // alerts on current (still open) bar?
extern bool            alertsMessage   = true;           // alerts message?
extern bool            alertsSound     = false;          // alerts sound?
extern bool            alertsNotify    = false;          // alerts notification?
extern bool            alertsEmail     = false;          // alerts email?
extern string          soundFile       = "alert2.wav";   // alerts sound file

//+++======================================================================+++
//+++                     Custom indicator buffers                         +++
//+++======================================================================+++
double Buf7[],Buf8[],SignalBuffer[];
double D10,D11,D12,D13,D14,D15,D16,D17;
double K10,K11,K12,K13,K14,K15,K16,K17;
double S10,S11,S12,S13,S14,S15,S16,S17;
double ExtBufferDN[],ExtBufferUP[];
double CLDN[],CLUP[],CO[];
double BbLo[],BbUp[],BbDn[];
double CCIBuffer[],state[];
//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init()
{
   K10=Stoch_K;    K11=K10*Koef;   K12=K11*Koef;   K13=K12*Koef;
   K14=K13*Koef;   K15=K14*Koef;   K16=K15*Koef;   K17=K16*Koef;
   
   D10=Stoch_D;    D11=D10*Koef;   D12=D11*Koef;   D13=D12*Koef;
   D14=D13*Koef;   D15=D14*Koef;   D16=D15*Koef;   D17=D16*Koef;
   
   S10=Stoch_S;    S11=S10*Koef;   S12=S11*Koef;   S13=S12*Koef;
   S14=S13*Koef;   S15=S14*Koef;   S16=S15*Koef;   S17=S16*Koef;
   
   IndicatorBuffers(9);   IndicatorDigits(Digits-3);   if (Digits==2 || Digits==3) IndicatorDigits(Digits-1);
   
   SetIndexBuffer(0,ExtBufferDN);
   SetIndexBuffer(1,ExtBufferUP);
   SetIndexBuffer(2,CLDN);
   SetIndexBuffer(3,CLUP); 
   SetIndexBuffer(4,CO);       
   SetIndexBuffer(5,Buf7);
   SetIndexBuffer(6,SignalBuffer);       
   SetIndexBuffer(7,CCIBuffer);      
   SetIndexBuffer(8,state);      
    
   int HLT=DRAW_NONE;   if (ShowHisto) HLT=DRAW_HISTOGRAM; 
   SetIndexStyle(0,HLT);
   SetIndexStyle(1,HLT);  
   SetIndexStyle(2,HLT);
   SetIndexStyle(3,HLT);
   SetIndexStyle(4,HLT);
   if (ShowStochX8) SetIndexStyle(5,DRAW_LINE);   else SetIndexStyle(5,DRAW_NONE);        
   SetIndexStyle(6,DRAW_LINE);
   SetIndexStyle(7,DRAW_LINE);
   
   SetIndexLabel(0,"DN");
   SetIndexLabel(1,"UP");
   SetIndexLabel(2,"CLDN");
   SetIndexLabel(3,"CLUP");
   SetIndexLabel(4,"CO");
   SetIndexLabel(5,"StochX8.4  ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_D)+","+IntegerToString(Stoch_S)+"]");
   if (ShowSignal) SetIndexLabel(6,"SignalMA   ["+IntegerToString(SignalMA)+"]");   else SetIndexLabel(6,NULL);
   if (ShowCCI)    SetIndexLabel(7,"CCI ["+IntegerToString(CCIPeriod)+"]");         else SetIndexLabel(7,NULL);
   
//+++======================================================================+++
//+++                      Stochastic-X8.4 vs CCI TT                       +++
//+++======================================================================+++

   SetIndexShift(0,StochShift);  
   SetIndexShift(1,StochShift);     
   SetIndexShift(2,StochShift);     
   SetIndexShift(3,StochShift);   
   SetIndexShift(4,StochShift);     
   SetIndexShift(5,StochShift);  
   SetIndexShift(6,SignalShift);  
   SetIndexShift(7,CCIShift);  
   
   SetIndexDrawBegin(0,StochShift+Stoch_D);     
   SetIndexDrawBegin(1,StochShift+Stoch_D);     
   SetIndexDrawBegin(2,StochShift+Stoch_D);  
   SetIndexDrawBegin(3,StochShift+Stoch_D);  
   SetIndexDrawBegin(4,StochShift+Stoch_D);
   SetIndexDrawBegin(5,StochShift+Stoch_D);   
   SetIndexDrawBegin(5,SignalShift+SignalMA);   
   SetIndexDrawBegin(5,CCIShift+CCIPeriod);   
   
//---- indicator short name
   string sim=StringSetChar("",0,164);
   if (ShowSignal) string labelM = " --> SignalMA ["+IntegerToString(SignalMA)+"]";
   if (ShowCCI)    string labelC = " ++ CCI ["+IntegerToString(CCIPeriod)+"]";
   IndicatorShortName("StochX8.4 TT ["+IntegerToString(Stoch_K)+","+IntegerToString(Stoch_D)+","+IntegerToString(Stoch_S)+"] "+sim+DoubleToString(Koef,2)+labelM+labelC);
   
//---- initialization done
return(0);
}
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit()  { return(0); }
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++

int start()
{
    int i, counted_bars=IndicatorCounted();
    if(counted_bars<0)    return(-1);
      
       if(History < 1)     History = Bars;
       if(counted_bars > 0)    counted_bars -= 0;
          
          int limit = MathMin(History-counted_bars,History-1);  
          if(limit<=0) limit=1;          
//+++======================================================================+++

    double m1,m2,m3,m4,m5,m6,m7,m8;
  
    for(i=0; i<limit; i++)
      {
       m1 = 2* NormalizeDouble(iStochastic(NULL,0,K10,D10,S10,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m2 = 2* NormalizeDouble(iStochastic(NULL,0,K11,D11,S11,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m3 = 2* NormalizeDouble(iStochastic(NULL,0,K12,D12,S12,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m4 = 2* NormalizeDouble(iStochastic(NULL,0,K13,D13,S13,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m5 = 2* NormalizeDouble(iStochastic(NULL,0,K14,D14,S14,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m6 = 2* NormalizeDouble(iStochastic(NULL,0,K15,D15,S15,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m7 = 2* NormalizeDouble(iStochastic(NULL,0,K16,D16,S16,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       m8 = 2* NormalizeDouble(iStochastic(NULL,0,K17,D17,S17,StochMode,StochPrice,MODE_MAIN,i)-50,Digits+1);
       
       Buf7[i] = (m1+m2+m3+m4+m5+m6+m7+m8)/8;
      }
//+++======================================================================+++

     for(i=limit; i>=0; i--) 
       {
        if (Buf7[i]<Buf7[i+1]) { ExtBufferDN[i]=Buf7[i]; ExtBufferUP[i]=0; }
        if (Buf7[i]>Buf7[i+1]) { ExtBufferUP[i]=Buf7[i]; ExtBufferDN[i]=0; }  
     
        if (Close[i]<Open[i])  { CLDN[i]=Buf7[i]/2; CLUP[i]=0; CO[i]=0;   }
        if (Close[i]>Open[i])  { CLUP[i]=Buf7[i]/2; CLDN[i]=0; CO[i]=0;   } 
        if (Close[i]==Open[i]) { CO[i]=Buf7[i]/2;   CLDN[i]=0; CLUP[i]=0; }
        
        if (ShowSignal) SignalBuffer[i] = iMAOnArray(Buf7,0,SignalMA,0,SignalMode,i);   else SignalBuffer[i]=EMPTY_VALUE;     
        if (ShowCCI)       CCIBuffer[i] = iCCI(NULL,0,CCIPeriod,CCIPrice,i) /Koef;      else CCIBuffer[i]=EMPTY_VALUE;      
        if (ShowCCI && ShowSignal)
        if (i<Bars-1) state[i] = (CCIBuffer[i]>SignalBuffer[i]) ? 1 : (CCIBuffer[i]<SignalBuffer[i]) ? -1 : state[i+1];
       }     
//----
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (state[whichBar] != state[whichBar+1])
      {
         if (state[whichBar]== 1) doAlert(whichBar,"up");
         if (state[whichBar]==-1) doAlert(whichBar,"down");
      }
   }
return(0);
}
//+++======================================================================+++
//+++                      Stochastic-X8.4 vs CCI TT                       +++
//+++======================================================================+++
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Stochastic vs CCI : cci crossed signal line "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" "+_Period+" Stochastic vs CCI ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
